--场景区域,变更前场景区域,可视区域,格子数,格子宽高
local areaRect,oldAreaRect,viewRect,oldViewRect,gridHNum,gridVNum,gridWidth,gridHeight

local function setGrid(w,h)
	gridWidth = w / gridHNum
	gridHeight = h / gridVNum
end

function initArea(tx, ty, tw, th, hn, vn)
	gridHNum = hn
	gridVNum = vn
	areaRect = {x=tx, y=ty, w=tw, h=th}
	oldAreaRect = {x=0, y=0, w=0, h=0}
	setGrid(tw,th)
end
function getCurArea()
	return areaRect.x,areaRect.y
end

--初始可视区域
function initView(tw, th)
	viewRect = {x=-gridWidth*1, y=-gridHeight*1, w=tw, h=th}
	oldViewRect = {x=0, y=0, w=0, h=0}
end
function getCurView()
	return viewRect
end

--初始订阅块
local blockHNum=0
local blockVNum=0
local blockWidth=0
local blockHeight=0
function initBlock(hn, vn)
	blockHNum=hn
	blockVNum=vn
	blockWidth=math.ceil(areaRect.w/hn)
	blockHeight=math.ceil(areaRect.h/vn)
end
function getCurBlock()
	local tx=math.modf((viewRect.x-areaRect.x)/blockWidth)+1
	local ty=math.modf((viewRect.y-areaRect.y)/blockHeight)
	local tx2=math.modf((viewRect.x+viewRect.w-areaRect.x)/blockWidth)+1
	local ty2=math.modf((viewRect.y+viewRect.h-areaRect.y)/blockHeight)
	if tx==tx2 and ty==ty2 then
		return {ty*blockHNum+tx}
	elseif tx==tx2 and ty~=ty2 then
		return {ty*blockHNum+tx,ty2*blockHNum+tx}
	elseif tx~=tx2 and ty==ty2 then
		return {ty*blockHNum+tx,ty*blockHNum+tx2}
	else
		return {ty*blockHNum+tx,ty*blockHNum+tx2,ty2*blockHNum+tx,ty2*blockHNum+tx2}
	end
end

--设置可视范围位置
function setAreaPos(x, y, refresh)
	if refresh==nil then
		if areaRect.x == x and areaRect.y == y then
			return
		end
	else
		oldAreaRect = {x=0, y=0, w=0, h=0}
	end
	areaRect.x = x
	areaRect.y = y
	viewChangeFun()
end

--缩放场景(中心缩放)
function zoomAreaFun(dx,dy)
	if dx == 0 and dy == 0 then
		return
	end
	areaRect.w=areaRect.w*dx
	areaRect.h=areaRect.h*dy
	setGrid(areaRect.w,areaRect.h)
	viewChangeFun()
end

--设置场景宽高
function setAreaSize(w, h)
	if areaRect.w == w and areaRect.h == h then
		return
	end
	zoomAreaFun((w-areaRect.w)/2,(h-areaRect.h)/2)
end


--设置可视范围宽高
function setViewSize(w, h, x, y)--fx 2014-4-15
	if viewRect.w == w and viewRect.h == h then
		return
	end
	oldViewRect = copytable(viewRect)
	viewRect.w = w
	viewRect.h = h
	viewRect.x = x
	viewRect.y = y
	print("setViewSize===========================",w,h,x,y)
	--oldAreaRect = {x=0, y=0, w=0, h=0}
	viewChangeFun();
end

--调整场景，校正超边界
local function areaReviseFun()
	if areaRect.x > (viewRect.x+viewRect.w/2-gridWidth) then
		areaRect.x = viewRect.x+viewRect.w/2-gridWidth
	end
	if (areaRect.x+areaRect.w) < (viewRect.x+viewRect.w/2) then
		areaRect.x = viewRect.x+viewRect.w/2 - areaRect.w
	end
	if areaRect.y > (viewRect.y+viewRect.h/2-gridHeight) then
		areaRect.y = viewRect.y+viewRect.h/2-gridHeight
	end
	if (areaRect.y+areaRect.h) < (viewRect.y+viewRect.h/2) then
		areaRect.y = viewRect.y+viewRect.h/2 - areaRect.h
	end
end

--视图变更(bl为true时强制更新,输出：>0为新增，<0为删除)
function viewChangeFun()
	--校正边界
	areaReviseFun()
	--取移动前后的位置
	local vl=math.modf((viewRect.x - areaRect.x) / gridWidth)
	local vt=math.modf((viewRect.y - areaRect.y) / gridHeight)
	local vr=math.ceil((viewRect.x+viewRect.w - areaRect.x) / gridWidth)
	local vb=math.ceil((viewRect.y+viewRect.h - areaRect.y) / gridHeight)
	
	
	if oldAreaRect.w==0 and oldAreaRect.h==0 then
		--新
		for i = vl ,vr-1  do
			for j = vt ,vb-1  do
				if i % 2 == j % 2 then
					addMapImage(i,j)
				end
			end
		end
		drawMapImage()
	else
		local ol,ot,ort,ob
		if oldViewRect.w == 0 and oldViewRect.h == 0 then
			ol=math.modf((viewRect.x - oldAreaRect.x) / gridWidth)
			ot=math.modf((viewRect.y - oldAreaRect.y) / gridHeight)
			ort=math.ceil((viewRect.x+viewRect.w - oldAreaRect.x) / gridWidth)
			ob=math.ceil((viewRect.y+viewRect.h - oldAreaRect.y) / gridHeight)
		else
			ol=math.modf((oldViewRect.x - oldAreaRect.x) / gridWidth)
			ot=math.modf((oldViewRect.y - oldAreaRect.y) / gridHeight)
			ort=math.ceil((oldViewRect.x+oldViewRect.w - oldAreaRect.x) / gridWidth)
			ob=math.ceil((oldViewRect.y+oldViewRect.h - oldAreaRect.y) / gridHeight)
			oldViewRect = {x=0, y=0, w=0, h=0}
		end
		if vl == ol and vt == ot and vr == ort and vb == ob then
			return
		end
		--相交部分
		local tbx = math.max(vl,ol)
		local tby = math.max(vt,ot)
		local tex = math.min(vr,ort)
		local tey = math.min(vb,ob)
		--删
		for i = ol ,ort-1  do
			for j = ot ,ob-1  do
				if i<tbx or i>=tex or j<tby or j>=tey then
					if i % 2 == j % 2 then
						delMapImage(i,j)
					end
				end
			end
		end
		--增
		for i = vl ,vr-1  do
			for j = vt ,vb-1  do
				if i<tbx or i>=tex or j<tby or j>=tey then
					if i % 2 == j % 2 then
						addMapImage(i,j)
					end
				end
			end
		end
		drawMapImage()
	end
	
	
	
	oldAreaRect.x = areaRect.x
	oldAreaRect.y = areaRect.y
	oldAreaRect.w = areaRect.w
	oldAreaRect.h = areaRect.h
end

--判断x,y点坐标在不在可视范围内
function checkXYInView(x,y)
	if viewRect == nil then
		return true--穿过
	end
	local bx = (viewRect.x - areaRect.x)
	local by = (viewRect.y - areaRect.y)
	local ex = (viewRect.x + viewRect.w - areaRect.x)
	local ey = (viewRect.y + viewRect.h - areaRect.y)
	if x >= bx and x <= ex and y >= by and y <= ey then
		return true
	end
	return false
end

--判断线段是否穿过可视范围
function checkRoadThroughBlock(fromP,toP)
	if viewRect == nil then
		return true--穿过
	end
	local a = fromP.y - toP.y
	local b = toP.x - fromP.x
	local c = toP.y * fromP.x - toP.x * fromP.y

	-- n个可能穿过的矩形
	local x1 = (viewRect.x - areaRect.x)
	local y1 = (viewRect.y - areaRect.y)
	local x2 = (viewRect.x + viewRect.w - areaRect.x)
	local y2 = (viewRect.y + viewRect.h - areaRect.y)
		
	--判断线段所在直线是否穿过某一矩形对角线
	if ((a * x1 + b * y1 + c) * (a * x2 + b * y2 + c) <= 0 or (a * x2 + b * y1 + c) * (a * x1 + b * y2 + c) <= 0) then
		--判断线段两个端点是否在矩形的同一侧
		if ((fromP.x < x1 and toP.x < x1) or (fromP.x > x2 and toP.x > x2)
				or (fromP.y < y1 and toP.y < y1)
				or (fromP.y > y2 and toP.y > y2)) then
				--未穿过
			return false
		else
			return true--穿过
		end
	end
	return false
end

--返回可视区域左右边线所在直线与军队路线的交点 序号
function getIndexForTroop(fx,tw)
	if viewRect == nil then
		return nil
	end
	return math.floor(((viewRect.x - areaRect.x) + 18 - fx) / tw),math.ceil(((viewRect.x + viewRect.w - areaRect.x) + 18 - fx) / tw)
end