--场景区域,变更前场景区域,可视区域,格子数,格子宽高
local areaRect,oldAreaRect,viewRect,gridHNum,gridVNum,gridWidth,gridHeight

local function setGrid(w,h)
	gridWidth = w / gridHNum
	gridHeight = h / gridVNum
end

function initArea2(tx, ty, tw, th, hn, vn)
	gridHNum = hn
	gridVNum = vn
	areaRect = {x=tx, y=ty, w=tw, h=th}
	oldAreaRect = {x=0, y=0, w=0, h=0}
	setGrid(tw,th)
end

--初始可视区域
function initView2(tw, th)
	viewRect = {x=-tw/4, y=-th/4, w=tw*1.5, h=th*1.5}
end

--设置可视范围位置
function setAreaPos2(x, y, refresh)
	if refresh==nil then
		if areaRect.x == x and areaRect.y == y then
			return
		end
	else
		oldAreaRect = {x=0, y=0, w=0, h=0}
	end
	areaRect.x = x
	areaRect.y = y
	viewChangeFun2()
end

--调整场景，校正超边界
local function areaReviseFun()
	if areaRect.x > (viewRect.x+viewRect.w/2-gridWidth) then
		areaRect.x = viewRect.x+viewRect.w/2-gridWidth
	end
	if (areaRect.x+areaRect.w) < (viewRect.x+viewRect.w/2) then
		areaRect.x = viewRect.x+viewRect.w/2 - areaRect.w
	end
	if areaRect.y > (viewRect.y+viewRect.h/2-gridHeight) then
		areaRect.y = viewRect.y+viewRect.h/2-gridHeight
	end
	if (areaRect.y+areaRect.h) < (viewRect.y+viewRect.h/2) then
		areaRect.y = viewRect.y+viewRect.h/2 - areaRect.h
	end
end

--视图变更(bl为true时强制更新,输出：>0为新增，<0为删除)
function viewChangeFun2()
	--校正边界
	areaReviseFun()
	--取移动前后的位置
	local vl=math.modf((viewRect.x - areaRect.x) / gridWidth)
	local vt=math.modf((viewRect.y - areaRect.y) / gridHeight)
	local vr=math.ceil((viewRect.x+viewRect.w - areaRect.x) / gridWidth)
	local vb=math.ceil((viewRect.y+viewRect.h - areaRect.y) / gridHeight)
	if oldAreaRect.w==0 and oldAreaRect.h==0 then
		--新
		for i = vl ,vr-1  do
			for j = vt ,vb-1  do
				addMapBGImage(i,j)
			end
		end
	else
		local ol=math.modf((viewRect.x - oldAreaRect.x) / gridWidth)
		local ot=math.modf((viewRect.y - oldAreaRect.y) / gridHeight)
		local ort=math.ceil((viewRect.x+viewRect.w - oldAreaRect.x) / gridWidth)
		local ob=math.ceil((viewRect.y+viewRect.h - oldAreaRect.y) / gridHeight)
		if vl == ol and vt == ot and vr == ort and vb == ob then
			return
		end
		--相交部分
		local tbx = math.max(vl,ol)
		local tby = math.max(vt,ot)
		local tex = math.min(vr,ort)
		local tey = math.min(vb,ob)
		--删
		for i = ol ,ort-1  do
			for j = ot ,ob-1  do
				if i<tbx or i>=tex or j<tby or j>=tey then
					delMapBGImage(i,j)
				end
			end
		end
		--增
		for i = vl ,vr-1  do
			for j = vt ,vb-1  do
				if i<tbx or i>=tex or j<tby or j>=tey then
					addMapBGImage(i,j)
				end
			end
		end
	end
	oldAreaRect.x = areaRect.x
	oldAreaRect.y = areaRect.y
	oldAreaRect.w = areaRect.w
	oldAreaRect.h = areaRect.h
end