--godsRelic
G_DE_GODS_RELIC_ENABLED = 1

local _adata 		= {}
local _adataDetail 	= {}

function godsRelic_tableSplit(v)
	local nid,ngrade,nCD,ntechParam1,ntechParam2,ntechParam3,ntechParam4,ntempParam1,ntempParam2,ntempParam3=v[1],v[2],v[3],v[4],v[5],v[6],v[7],v[8],v[9],v[10]
	return nid,ngrade,nCD,ntechParam1,ntechParam2,ntechParam3,ntechParam4,ntempParam1,ntempParam2,ntempParam3
end

function godsRelic_detailTableSplit(v)
	local nlv,npreVal,ncurVal,ntempParam1,ntempParam2,ntempParam3=v[1],v[2],v[3],v[4],v[5],v[6]
	return nlv,npreVal,ncurVal,ntempParam1,ntempParam2,ntempParam3
end

function godsRelic_getGodsRelic(nid)
	local v = tabmgr_query(_adata,nid)
	if v ~= nil then 
		return v
	end
	return {}
end

function godsRelic_getGodsRelicDetail(nid)
	local v = tabmgr_query(_adataDetail,nid)
	if v == nil then 
		godsRelic_GetGodsRelicDetailFromSrv(nid)
		
		return {}
	else
		return v
	end
end

function godsRelic_GetGodsRelicDetailFromSrv(nid,nneedLoading)
	if nneedLoading == nil then nneedLoading = 1 end
	print("=============== godsRelic_GetGodsRelicDetailFromSrv nid:"..nid)
	if nid > 0 then 
		httpsend( 1 , 0x005a , 0 , {CUserData.m_nUserID,nid},"godsRelic_onRecMsgGetGodsRelicDetail","httpdp_svrStatusLogin"  )			
		if 1 == nneedLoading then 
			btnloading_show()
		end
	end
end

function godsRelic_onRecMsgGetGodsRelicDetail(ntype , nseqno , nret , arg )--登陆时，处理服务器消息	
	print(string.format("godsRelic_onRecMsgGetGodsRelicList ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	http_getdata(ntype , nseqno , nret , arg)
	btnloading_del()
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	local nid 			= arg[2]
	local adataDetail 	= arg[3]
	tabmgr_insert(_adataDetail,{nid,adataDetail})
	
	godsRelicUpgrade_onRecMsgDetail(nid)
end

function godsRelic_GetGodsRelicList()
	httpsend( 1 , 0x0059 , 0 , {CUserData.m_nUserID},"godsRelic_onRecMsgGetGodsRelicList","httpdp_svrStatusLogin"  )			
end

function godsRelic_onRecMsgGetGodsRelicList(ntype , nseqno , nret , arg )--登陆时，处理服务器消息	
	print(string.format("== =====================godsRelic_onRecMsgGetGodsRelicList ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	http_getdata(ntype , nseqno , nret , arg)
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	_adata = arg[2]
	
	for _,v in pairs(_adata ) do
		local nid,ngrade,nCD,ntechParam1,ntechParam2,ntechParam3,ntechParam4,ntempParam1,ntempParam2,ntempParam3 = godsRelic_tableSplit(v)
		godsRelic_GetGodsRelicDetailFromSrv(nid,0)
	end
end

function godsRelic_onRecMsgSNGodsRelic(arg)
	print("godsRelic_onRecMsgSNGodsRelic arg".. tabletostring(arg))
	local v = copytable(arg)
	table.remove(v,1)
	
	tabmgr_insert(_adata,v)
	
	local nid = v[1]
	godsRelicList_onActive(nid)
	godsRelicTech_onActive(nid)
end

function godsRelic_Compose(nid)
	httpsend( 1 , 0x0173 , 0 , {CUserData.m_nUserID,nid,0,0,0,0},"godsRelic_onRecMsgGodsRelicCompose","httpdp_svrStatusLogin"  )			
end

function godsRelic_onRecMsgGodsRelicCompose(ntype , nseqno , nret , arg )--登陆时，处理服务器消息	
	print(string.format("godsRelic_onRecMsgGodsRelicCompose ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	http_getdata(ntype , nseqno , nret , arg)
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	local nid = arg[2]
	
	local v = {arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10],arg[11] }
	
	tabmgr_insert(_adata,v)
	
	local nitemId 	= arg[12]
	local nitemNum 	= arg[13]
	itemshop_set(nitemId,nitemNum)
	
	local nitemId 	= arg[14]
	local nitemNum 	= arg[15]
	itemshop_set(nitemId,nitemNum)
	
	CUserData.m_nLordPower = arg[16]
	
	godsRelicList_onIntegrade(nid)
	godsRelicTech_onIntegrade(nid)
end


function godsRelic_Upgrade(nid)
	httpsend( 1 , 0x0174 , 0 , {CUserData.m_nUserID,nid,0,0,0,0},"godsRelic_onRecMsgGodsRelicUpgrade","httpdp_svrStatusLogin"  )			
end

function godsRelic_onRecMsgGodsRelicUpgrade(ntype , nseqno , nret , arg )--登陆时，处理服务器消息	
	print(string.format("godsRelic_onRecMsgGodsRelicUpgrade ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	http_getdata(ntype , nseqno , nret , arg)
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	local nid = arg[2]
	local v = {arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10],arg[11] }
	
	tabmgr_insert(_adata,v)
	
	local nitemId 	= arg[12]
	local nitemNum 	= arg[13]
	itemshop_set(nitemId,nitemNum)
	
	CUserData.m_nLordPower = arg[14]
	
	godsRelicList_onUpgrade(nid)
	godsRelicUpgrade_onUpgrade(nid)
	godsRelicTech_onUpgrade(nid)
end

function godsRelic_Refresh(nid,nlv,nisBack)
	httpsend( 1 , 0x0175 , 0 , {CUserData.m_nUserID,nid,nlv,nisBack,0,0,0},"godsRelic_onRecMsgGodsRelicRefresh","httpdp_svrStatusLogin"  )			
end

function godsRelic_onRecMsgGodsRelicRefresh(ntype , nseqno , nret , arg )--登陆时，处理服务器消息	
	print(string.format("godsRelic_onRecMsgGodsRelicRefresh ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	http_getdata(ntype , nseqno , nret , arg)
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	local nid = arg[2]
	local ncurIndex = arg[3]
	local v = {arg[3],arg[4],arg[5],arg[6],arg[7],arg[8] }
	
	local adetail = tabmgr_query(_adataDetail,nid)
	if adetail ~= nil then 
		print("godsRelic_onRecMsgGodsRelicRefresh adetail:"..tabletostring(adetail))
		print("godsRelic_onRecMsgGodsRelicRefresh v:"..tabletostring(v))
		tabmgr_insert(adetail[2],v)
	else
		local vv = {nid,v }
		tabmgr_insert(_adataDetail,vv)
	end
	
	local nitemId 	= arg[9]
	local nitemNum 	= arg[10]
	itemshop_set(nitemId,nitemNum)
	
	local nparam1 = arg[6]
	if 1 == nparam1 then 
		
	else
		
	end
	user_updateGold(arg[11])
	user_updateSilve(arg[12])
	
	godsRelicUpgrade_onRefresh(nid,ncurIndex)
end

function godsRelic_Active(nid)
	httpsend( 1 , 0x0176 , 0 , {CUserData.m_nUserID,nid,0,0,0,0},"godsRelic_onRecMsgGodsRelicActive","httpdp_svrStatusLogin"  )			
end

function godsRelic_onRecMsgGodsRelicActive(ntype , nseqno , nret , arg )--登陆时，处理服务器消息	
	print(string.format("godsRelic_onRecMsgGodsRelicActive ntype:%x ：nseqno:%d nret:%d",ntype , nseqno , nret) )
	http_getdata(ntype , nseqno , nret , arg)
	if nret ~= 0 then --表示处理消息失败
		return
	end
	table.insert(arg,1,nret)
	print( string.format("接受消息 0x%x nseqno=%d ret=%d %s httpdp_revMsgLogin" , ntype , nseqno , nret, tabletostring(arg) ) )
	
	--银币arg[12]
	CUserData.m_nSilver=arg[12]--银币
	--兵种编号arg[13]
	--获得数量arg[14]
	--当前数量arg[15]
	if arg[13] > 0 then 
		local nfind = 0
		for i = 1 , #CUserData.m_aSoldier do--个人兵种{兵种编号,士兵数量,伤兵数量}
			if CUserData.m_aSoldier[i][1] == arg[13] then
				CUserData.m_aSoldier[i][2] = arg[15]
--				CUserData.m_aSoldier[i][3] = arg[5]
				nfind = 1
				break
			end
		end
		if nfind == 0 then
			table.insert(CUserData.m_aSoldier,{arg[13],arg[15],0})
		end
		local szSoldierName = cfgmgr_queryValue(G_DE_CFG_SOLDIER_UPG,arg[13],"F2")
		print("godsRelic_onRecMsgGodsRelicActive szSoldierName:" .. szSoldierName)
		local str = "获得:".." " ..szSoldierName  .." " .."x" .. arg[14]
		print("godsRelic_onRecMsgGodsRelicActive str:" .. str)
		showClum({str,1})		
	end
	
	local nid = arg[2]
	local v = {arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10],arg[11] }
	
	tabmgr_insert(_adata,v)
	
	godsRelicList_onActive(nid)
	godsRelicTech_onActive(nid)
	
	city_TopRef()
end


